using System;
using System.IO;
using System.Collections.Generic;

namespace Exercises_C_Sharp.E20_Lists
{
    class Exercise_9
    {
        public static void Start()
        {

            List<int> intList = new List<int>() {46,45,2,3,-8,15,14,16,35,86,-84,25,78,6,32,-15,99,87, -38, 64, -42};

            //Kontrolle:
            Meth(intList);
            
        }

        //Schreiben Sie eine Methode, die alle Werte einer Integerliste als String ausgibt. So soll er beispielsweise bei der 1 -> "Eins" ausgeben und bei der 34 -> "Vierunddreißig". Es reicht aus, wenn es für ein und zweistellige Zahlen funktioniert. Schauen Sie auch, dass auch negative Zahlen ausgegeben werden:
        static void Meth(List<int> intList)
        {
            /*Code START*/
            List<string> EinerList = ["Null", "Ein", "Zwei", "Drei", "Vier", "Fünf", "Sechs", "Sieben", "Acht", "Neun"];
            List<string> ZehnerList = ["NULL", "Zehn", "Zwanzig", "Dreißig", "Vierzig", "Fünfzig", "Sechzig", "Siebzig", "Achtzig", "Neunzig"];

            foreach(var element in intList)
            {
                int number = element;
                string result = string.Empty;

                if(number < 0)
                {
                    result = "Minus ";
                    number = Math.Abs(number);
                }
                int einer = number % 10;
                int zehner = number / 10;

                if(number == 1)
                    result += "Eins";
                else if(number == 11)
                    result += "Elf";
                else if(number == 12)
                    result += "Zwölf";
                else if(number == 16)
                    result += "Sechzehn";
                else if(number == 17)
                    result += "Siebzehn";
                else if(number > 12 && number < 20)
                    result += EinerList[einer] + ZehnerList[zehner].ToLower();
                else if(zehner == 0)
                    result += EinerList[einer];
                else if(einer == 0)
                    result += ZehnerList[zehner];
                else
                    result += EinerList[einer] + "und" + ZehnerList[zehner].ToLower();


                Console.WriteLine(result);

            }

            /*Code ENDE*/
        }
    }
}